# LITMUSCHAOS MENTORING

This document serves as a comprehensive record of mentees, mentors, issues, and blogs associated with prominent open source programs such as LFX Mentorship, Google Summer of Code, Google Season of Docs, and Outreachy. Its primary objective is to provide an organized overview of mentoring activities and effectively track the progress made within the project.

## Mentoring Details

| Program                     | Timeline                            | Mentee                                          | Mentor(s)                                                                                          | Github Issue                                      | Blog(s)                                                                                                                                                                                                                                                        |
|-----------------------------|-------------------------------------|-------------------------------------------------|----------------------------------------------------------------------------------------------------|---------------------------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| Google Summer of Code (GSoC) | May 17th - August 31st, 2021        | [Hemanth Krishna](https://github.com/DarthBenro008) | [Raj Babu Das](https://github.com/imrajdas), [Karthik S](https://github.com/ksatchit)              | https://github.com/litmuschaos/litmus/issues/2483 | [Blog](https://darthbenro008.medium.com/google-summer-of-code-2021-with-cloud-native-compute-foundation-my-experience-with-litmuschaos-18f1ec3e5bfa),  [CNCF blog](https://www.cncf.io/blog/2021/08/19/__trashed-2/)                                           |
| LFX Mentorship              | September 1st - November 31st, 2021 | [Dhananjay Purohit](https://github.com/DhananjayPurohit)           | [Vedant Shrotria](https://github.com/jonsy13), [Raj Babu Das](https://github.com/imrajdas)         | https://github.com/litmuschaos/litmus/issues/3114 | [Blog](https://dhananjaypurohit.medium.com/getting-started-my-journey-with-lfx-mentorship-and-litmuschaos-3514eacf6df2)                                                                                                                                        |
| LFX Mentorship              | September 1st - November 31st, 2021 | [Aman Dwivedi](https://github.com/Aman-Codes)                      | [Udit Gaurav](https://github.com/uditgaurav), [Soumya Ghosh Dastidar](https://github.com/gdsoumya) | https://github.com/litmuschaos/litmus/issues/3112 | [Blog](https://aman-codes.medium.com/kick-start-of-my-lfx-mentorship-with-litmus-chaos-eeb089a10951),  [CNCF blog](https://www.cncf.io/blog/2022/08/11/my-experience-contributing-to-litmuschaos-as-a-student)                                                 |
| LFX Mentorship              | March 1st - May 31st, 2022          | [Prayag Savsani](https://github.com/PrayagS)                       | [Saranya Jena](https://github.com/Saranya-jena), [Sarthak Jain](https://github.com/SarthakJain26)  | https://github.com/litmuschaos/litmus/issues/3440 | --                                                                                                                                                                                                                                                             |
| LFX Mentorship              | March 1st - May 31st, 2023          | [NamKyu Park](https://github.com/namkyu1999)                       | [Sayan Mondal](https://github.com/S-ayanide), [Amit Kumar Das](https://github.com/amityt)          | https://github.com/litmuschaos/litmus/issues/3892 | [Blog](https://dev.to/namkyu1999/my-lfx-mentorship-journey-the-best-starting-point-for-contributing-to-open-source-4f35),  [CNCF blog](https://www.cncf.io/blog/2023/05/30/my-lfx-mentorship-journey-the-best-starting-point-for-contributing-to-open-source/) |
| LFX Mentorship              | June 1st - August 31st, 2023        | [Soham Ratnaparkhi](https://github.com/SohamRatnaparkhi)           | [Amit Kumar Das](https://github.com/amityt), [Arkajyoti Mukherjee](https://github.com/arkajyotiMukherjee) | https://github.com/litmuschaos/litmus/issues/3970 | --                                                                                                                                                                                                                                                             |
| LFX Mentorship              | June 1st - August 31st, 2023        | [Nagesh Bansal](https://github.com/Nageshbansal)           | [Shubham Chaudhary](https://github.com/ispeakc0de), [Vansh Bhatia](https://github.com/vanshBhatia-A4k9) | https://github.com/litmuschaos/litmus/issues/3969 | [Blog](https://dev.to/nageshbansal/exploring-litmusctl-a-comprehensive-guide-170k)                                                                                                                                                                                       |
| LFX Mentorship               | September 1st - November 30th, 2023 | [Magnim Thibaut Freedisch Batale](https://github.com/Freedisch) | [Saranya Jena](https://github.com/Saranya-jena), [Sayan Mondal](https://github.com/S-ayanide)            | https://github.com/litmuschaos/litmus/issues/4102 | [Blog](https://dev.to/freedisch_10/embarking-on-a-professional-growth-adventure-insights-from-my-lfx-mentorship-program-at-litmuschaos-5cbc)                                                                                                                  |
| LFX Mentorship               | September 1st - November 30th, 2023 | [Deep Poharkar](https://github.com/deep-poharkar)               | [Sarthak Jain](https://github.com/SarthakJain26), [Neelanjan Manna](https://github.com/neelanjan00)       | https://github.com/litmuschaos/litmus/issues/4101 | -- |
| LFX Mentorship              | March 1st - April 31st, 2024 | [Aryan Bhokare](https://github.com/aryan-bhokare)           | [Saranya Jena](https://github.com/Saranya-jena), [Hrishav Kumar](https://github.com/hrishavjha), [Sahil Kumar](https://github.com/SahilKr24)         | https://github.com/litmuschaos/litmus/issues/4407 | --
| LFX Mentorship              | March 1st - April 31st, 2024 | [Shivam Purohit](https://github.com/shivam-Purohit)           | [Sarthak Jain](https://github.com/SarthakJain26), [Vedant Shrotria](https://github.com/jonsy13), [Nagesh Bansal](https://github.com/Nageshbansal)         | https://github.com/litmuschaos/litmus/issues/4405 | --
| LFX Mentorship              | March 1st - April 31st, 2024 | [M R DHANUSH](https://github.com/Dhanush0369)           | [Raj Babu Das](https://github.com/imrajdas), [Shubham Chaudhary](https://github.com/ispeakc0de), [NamKyu Park](https://github.com/namkyu1999)         | https://github.com/litmuschaos/litmus/issues/4406 | --                                                                                                                                        |

> Refer to the [CNCF Mentoring](https://github.com/cncf/mentoring) repository for more details.

We sincerely thank all the mentors, mentees, organizations, and programs involved in this project for their invaluable support and contributions. Their dedication and commitment play a vital role in the success of our mentoring initiatives.

--x--